<?php
/*
Plugin Name: Handy Slider Widget
Plugin URI: http://wordpress.org/extend/plugins/handy-slider-widget/
Description: You can easily add post/image slider to your WordPress sidebar with this widget.
Author: Vatanay Ozbeyli
Version: 1.0
Author URI: http://adobewordpress.com
License: GPL2

    Copyright 2012 Vatanay Ozbeyli  (email : vatanay@adobewordpress.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2, 
    as published by the Free Software Foundation. 
    
    You may NOT assume that you can use any other version of the GPL.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    The license for this software can likely be found here: 
    http://www.gnu.org/licenses/gpl-2.0.html
    
*/
class Handy_Slider extends WP_Widget {
	
	function Handy_Slider() {
		$widget_ops = array('classname' => 'widget_handyslider', 'description' => __('Add handy slider to sidebar'));
		$this->WP_Widget('handyslider', __('Handy Slider Widget'), $widget_ops, $control_ops);
	}
	
	

	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters( 'widget_title', empty($instance['title']) ? '' : $instance['title'], $instance );
		$text = apply_filters( 'widget_handyslider', $instance['text'], $instance );
		echo $before_widget;
		if ( !empty( $title ) ) { echo $before_title . $title . $after_title; } 
			ob_start();
			eval('?>'.$text);
			$text = ob_get_contents();
			ob_end_clean();
			
			
		wp_enqueue_script('jquery');
		wp_enqueue_script('jquery-ui-core');
		wp_enqueue_script('jquery-ui-sortable');
		?>			
         
<style type="text/css">
/* Edit these codes for re-design your slider */

.handy-slider{position:relative;padding:2px;}

#ribbon {position:absolute;top:-1px;left:-1px;z-index:500;}

.rs-slideshow {
	width: <?php echo $instance['width'];?>;
	height: <?php echo $instance['height'];?>;
	overflow: hidden;
	position: relative;
	<?php if ($instance['shadowhs']){echo   '	-webkit-box-shadow: 0px 5px 10px rgba(0, 0, 0, 0.2);-moz-box-shadow: 0px 5px 10px rgba(0, 0, 0, 0.2);box-shadow: 0px 5px 10px rgba(0, 0, 0, 0.2);';}?>
}

.slide-container {background:url(<?php echo WP_PLUGIN_URL;?>/handy-slider-widget/img/default.jpg);width: <?php echo $instance['width'];?>;height: <?php echo $instance['height'];?>;}

.rs-slideshow .slide-container {
	background-color: #444;
	position: absolute;
	height: 100%;
	left: 0;
	overflow: hidden;
	top: 0;
	width: 100%;
}

.rs-slideshow .slide-container img {
	width: <?php echo $instance['width'];?>;
	height: <?php echo $instance['height'];?>;
}

.rs-slideshow .slide-container .slide-caption {
	background-color: #000;
	bottom: 0;
	color: #fff !important;
	display: block;
	left: 0;
	padding: 4px;
	position: absolute;
	text-align: left;
	font-size:11px;
	right: 0;
	filter: alpha(opacity=70); /* internet explorer */
	-khtml-opacity: 0.7;      /* khtml, old safari */
	-moz-opacity: 0.7;       /* mozilla, netscape */
	opacity: 0.7;           /* fx, safari, opera */
}

.rs-slideshow .slides {
	display: none;
}

.rs-slideshow .slide-container img,
.rs-slideshow .slide-container .slide-caption,
.rs-slideshow .slide-container a {
	filter: inherit;
}


.no-js .rs-slideshow {
	height: auto;
}
.no-js .rs-slideshow .slide-container, 
.no-js .rs-slideshow .slide-container img {
	position: relative;
}
.no-js .rs-slideshow .slides {
	display: block;
	margin: 24px 48px;
}
.no-js .rs-slideshow .slides li {
	margin: 0;
}

/*	Clearfix	*/
.clearfix:after { content: "."; display: block; height: 0; clear: both; visibility: hidden; }
.clearfix { display: inline-block; }
* html .clearfix { height: 1%; } /* Hides from IE-mac \*/
.clearfix { display: block; }

</style>

<?php	


if ($instance['postsets']=='1'){$postimgz=wp_get_attachment_url( get_post_thumbnail_id($post->ID) );}
else{		
function catch_that_image() {
  $first_img = '';
  ob_start();
  ob_end_clean();
  $output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
  $first_img = $matches [1] [0];

  if(empty($first_img)){ //Defines a default image
    $first_img = "".WP_PLUGIN_URL."/handy-slider-widget/img/default.jpg";
  }
  return $first_img;
}
$postimgz=catch_that_image();
}

?>

<div class="handy-slider">
<?php if ($instance['ribbonopt']){echo   '<a href="http://wordpress.org/extend/plugins/handy-slider-widget/" target="_blank"><img src="'.WP_PLUGIN_URL.'/handy-slider-widget/img/new-video.png" title="Add slider widget to your blog!" id="ribbon"></a>';} ?>
<div id="slideshow" class="rs-slideshow">
<div class="slide-container">
</div>
    
				<ol class="slides">
                <?php query_posts('cat='.$instance['cat_ids'].'&orderby=date&order=DESC&showposts='.$instance['limit'].''); ?>
                <?php while (have_posts()) : the_post(); if ($instance['postsets']=='1'){if( has_post_thumbnail()) {?>
				<li><a href="<?php echo wp_get_attachment_url( get_post_thumbnail_id($post->ID) ); ?>" title="<?php the_title(); ?>" data-link-to="<?php the_permalink(); ?>"></a></li>
                <?php }}else{?>
                <li><a href="<?php if( has_post_thumbnail()) {echo wp_get_attachment_url( get_post_thumbnail_id($post->ID) );}else{echo catch_that_image();} ?>" title="<?php the_title(); ?>" data-link-to="<?php the_permalink(); ?>"></a></li>
                <?php }endwhile; wp_reset_query()?>	
					</ol>
			</div>
</div>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
<script src="<?php echo WP_PLUGIN_URL;?>/handy-slider-widget/js/jquery.rs.slideshow.js"></script>
<script src="<?php echo WP_PLUGIN_URL;?>/handy-slider-widget/js/bootstrap.js"></script>
    
 
		<?php
		echo $after_widget;
	}
	

	function update($new_instance, $old_instance) {
		if (!isset($new_instance['submit'])) {
			return false;
		}
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['limit'] = intval($new_instance['limit']);
		$instance['width'] = $new_instance['width'];
		$instance['height'] = $new_instance['height'];
		$instance['cat_ids'] = strip_tags($new_instance['cat_ids']);
		$instance['ribbonopt'] = strip_tags($new_instance['ribbonopt']);
		$instance['shadowhs'] = strip_tags($new_instance['shadowhs']);
		$instance['postsets'] = strip_tags($new_instance['postsets']);
		return $instance;
	}


	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'text' => '', 'limit' => 10, 'cat_ids' => '0', 'width' => '210px', 'height' => '210px', 'ribbonopt' => '1', 'shadowhs' => '1' ,'postsets' => '1') );
		$title = strip_tags($instance['title']);
		$limit = intval($instance['limit']);
		$width = $instance['width'];
		$height = $instance['height'];
		$cat_ids = esc_attr($instance['cat_ids']);
		$ribbonopt = esc_attr($instance['ribbonopt']);
		$shadowhs = esc_attr($instance['shadowhs']);
		$postsets = esc_attr($instance['postsets']);
?>
<p><label for="<?php echo $this->get_field_id('title'); ?>">Title</label>
<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>

<p><label for="<?php echo $this->get_field_id('width'); ?>"><?php _e('Width:'); ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('width'); ?>" name="<?php echo $this->get_field_name('width'); ?>" type="text" value="<?php echo esc_attr($width); ?>" /><small><?php _e('* Default and minimum prefered value is 210px'); ?></small></p>

<p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('Height:'); ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo esc_attr($height); ?>" /><small><?php _e('* Default and minimum prefered value is 210px'); ?></small></p>

<p><label for="<?php echo $this->get_field_id('cat_ids'); ?>"><?php _e('Category IDs:'); ?> <span style="color: red;">*</span> <input class="widefat" id="<?php echo $this->get_field_id('cat_ids'); ?>" name="<?php echo $this->get_field_name('cat_ids'); ?>" type="text" value="<?php echo $cat_ids; ?>" /></label><small><?php _e('* If you want to display all cats,do not fill it.'); ?></small></p>

<p><label for="<?php echo $this->get_field_id('limit'); ?>"><?php _e('No. Of Records To Show:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('limit'); ?>" name="<?php echo $this->get_field_name('limit'); ?>" type="text" value="<?php echo $limit; ?>" /></label></p>

<p><label for="<?php echo $this->get_field_id('postsets'); ?>"><?php _e('Show posts:'); ?> 

<select id="<?php echo $this->get_field_name('postsets'); ?>" name="<?php echo $this->get_field_name('postsets'); ?>" class="widefat">
<option value="1" <?php if ($instance['postsets'] == "1"){echo 'selected';} ?>>Posts only if has thumbnail</option>
<option value="0" <?php if ($instance['postsets'] == "0"){echo 'selected';} ?>>Use any image inside posts</option>
</select>
</label>
</p>

<p><label for="<?php echo $this->get_field_name('shadowhs'); ?>">Use shadow?</label>

<input type="checkbox" name="<?php echo $this->get_field_name('shadowhs'); ?>" id="<?php echo $this->get_field_name('shadowhs'); ?>" <?php if ($instance['shadowhs'] == "1"){echo 'checked="checked"';} ?> value="1"/></p>

<p><label for="<?php echo $this->get_field_name('ribbonopt'); ?>">Show ribbon?</label>

<input type="checkbox" name="<?php echo $this->get_field_name('ribbonopt'); ?>" id="<?php echo $this->get_field_name('ribbonopt'); ?>" <?php if ($instance['ribbonopt'] == "1"){echo 'checked="checked"';} ?> value="1"/></p>
<input type="hidden" id="<?php echo $this->get_field_id('submit'); ?>" name="<?php echo $this->get_field_name('submit'); ?>" value="1" />

<?php
	}
}

add_action('widgets_init', create_function('', 'return register_widget("Handy_Slider");'));

// donate link on manage plugin page
add_filter('plugin_row_meta', 'handyslider_donate_link', 10, 2);
function handyslider_donate_link($links, $file) {
	if ($file == plugin_basename(__FILE__)) {
		$donate_link = '<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=adobewordpress@gmail.com">Donate</a>';
		$links[] = $donate_link;
	}
	return $links;
}